import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;

/**
 * Starter file for homework 6:
 * 
 * @author WRITE YOUR NAME HERE
 *
 * In this file, the user enters a file to read from and presses
 * a button. The program computes and displays the number of lines
 * in the text, the number of words in the text, and the number of
 * characters in the text.  A word is defined to be a sequence of
 * letters, except that an apostrophe with a letter on each side
 * of it is considered to be a letter.  (Thus "can't" is one word,
 * not two.)
 */
public class TextCounterStarter extends JPanel implements ActionListener{  
    
    private JTextArea textInput;     // For the user's input text.
    
    private JLabel lineCountLabel;   // For displaying the number of lines.
    private JLabel wordCountLabel;   // For displaying the number of words.
    private JLabel charCountLabel;   // For displaying the number of chars.
    
    private static JButton countButton; // For starting the text processing
    private static String title; // file name read from user
    /**
     * A main routine allows this class to be run as an application.
     */
    public static void main(String[] args) {
        JFrame window = new JFrame("Text Counter");
        TextCounter content = new TextCounter();
        window.setContentPane(content);
        window.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        window.setLocation(120,70);
        window.setSize(300,350);
        window.setVisible(true);
        title = JOptionPane.showInputDialog("Please enter a file "+
                                            "to read from and then\n"+
                                            "press \"Process Input\" button: ");
        countButton.setEnabled(true);
    }
    
    //---------------------------------------------------------------------
    
    /**
     * The constructor creates components and lays out the panel.
     */ 
    public TextCounterStarter() {
        
        setBackground(Color.DARK_GRAY);
        
        /* Create the text input area and make sure it has a
         white background. */       
        textInput = new JTextArea();
        textInput.setBackground(Color.WHITE);
        textInput.setLineWrap(true);
        textInput.setWrapStyleWord(true);
        
        /* Create a panel to hold the button and three display
         labels.  These will be laid out in a GridLayout with
         4 rows and 1 column. */
        
        JPanel south = new JPanel();
        south.setBackground(Color.DARK_GRAY);
        // the next line makes 4 rows with 2 pixel borders
        // for the JButton and 3 JLabels
        south.setLayout( new GridLayout(4,1,2,2) );
        
        /* instantiate the button, add a listener for
         clicks on the button, and add it to the panel. */    
        countButton = new JButton("Process Input");
        countButton.addActionListener(this);
        countButton.setEnabled(false);
        south.add(countButton);
        
        /* Create each of the labels, set their colors, and
         add them to the panel. */
        
        lineCountLabel = new JLabel("  Number of lines:");
        lineCountLabel.setBackground(Color.WHITE);
        lineCountLabel.setForeground(Color.BLUE);
        lineCountLabel.setOpaque(true);
        south.add(lineCountLabel);
        
        wordCountLabel = new JLabel("  Number of words:");
        wordCountLabel.setBackground(Color.WHITE);
        wordCountLabel.setForeground(Color.BLUE);
        wordCountLabel.setOpaque(true);
        south.add(wordCountLabel);
        
        charCountLabel = new JLabel("  Number of chars:");
        charCountLabel.setBackground(Color.WHITE);
        charCountLabel.setForeground(Color.BLUE);
        charCountLabel.setOpaque(true);
        south.add(charCountLabel);
        
        /* Use a BorderLayout on the main panel.  Although a BorderLayout
         is the default, I want one with a vertical gap of two
         pixels, to let the dark gray background color show through.
         Also add a gray border around the panel. */
        
        setLayout( new BorderLayout(2,2) );
        setBorder(BorderFactory.createLineBorder(Color.DARK_GRAY));
        
        /* The text area is put into a JScrollPane to provide
         scroll bars for the TextArea, and the scroll pane is put in
         the Center position.  The panel that holds the button and
         labels is in the South position.  Note that the text area
         will be sized to fill the space that is left after the
         panel is assigned its preferred height. */
        
        JScrollPane scroller = new JScrollPane( textInput );
        add(scroller, BorderLayout.CENTER);
        add(south, BorderLayout.SOUTH);
        
        
    } // end constructor
    
    /**
     * actionPerformed method set up to listen for the
     * JButton 
     */
    public void actionPerformed(ActionEvent evt) {
        if (evt.getSource() instanceof JButton) {
            //processInput();
        }
    }
    
    /**
     * Method processInput
     *
     * This will be called by the action listener for the 
     * JButton. It reads the text from the data file title,
     * declared in the main method, and counts the number
     * of chars, words, and lines that it contains, sets the 
     * 3 JLabels to display the results, and writes the file
     * in the JTextArea.
     */
    public void processInput()  {
        // Write code to declare and instantiate a BufferedReader
        // inside a try block.
        
    }  // end processInput()
    
    
} // end class TextCounter
